% % paper information
% % Qingxiang Feng and yicong zhou, Kernel Combined Sparse Representation
% for Disease Recognition-Double Column, IEEE TMM
% % fengqx1988@gmail.com and yicongzhou@umac.mo

% % % Produce the random train and test data
samdim=200;
class=10;

Jtrain=rand(samdim,5*class);
trlab=ones(5,1)*[1:class];
trlab=trlab(:)';

Jtest=rand(samdim,10*class);
ttlab=ones(10,1)*[1:class];
ttlab=ttlab(:)';
% % % End of Producing the random train and test data


[~,alltrainsamnum]=size(Jtrain);
[~,alltestsamnum]=size(Jtest);

% % % compute the kernel parameter
meansam=mean(Jtrain,2);
paraarr=zeros(1,alltrainsamnum);
for i=1:alltrainsamnum
    paraarr(i)=1/norm(Jtrain(:,i)-meansam)^2;
end
canshu=mean(paraarr)/9;

fprintf(['RateCSR: ' num2str(TLC(Jtrain'*Jtrain,trlab,Jtrain'*Jtest,ttlab)) '\n']);



% % % constitute kernel matrix of train
Ktrain=zeros(alltrainsamnum,alltrainsamnum);
for ik=1:alltrainsamnum
    for jk=ik:alltrainsamnum
        x=Jtrain(:,ik)';
        y=Jtrain(:,jk)';
        Ktrain(ik,jk)=kernel(x,y,canshu);
        Ktrain(jk,ik)=Ktrain(ik,jk);
    end
end

% % % constitute kernel matrix of test
Ktest=zeros(alltrainsamnum,alltestsamnum);
for ik=1:alltestsamnum
    for jk=1:alltrainsamnum
        x=Jtest(:,ik)';
        y=Jtrain(:,jk)';
        Ktest(jk,ik)=kernel(x,y,canshu);
    end
end

fprintf(['RateKCSR: ' num2str(TLC(Ktrain,trlab,Ktest,ttlab)) '\n']);

% % % % Center JtrainC
JtrainC=[];
trlabC=[];
for i=1:class
    temfinlab=find(trlab==i);
    [finlab1, finlab2]=size(temfinlab);
    sample_num=finlab1*finlab2;
    Jtem=Jtrain(:,temfinlab);
    trlabtem=trlab(temfinlab);
    
    meansam=mean(Jtem,2);
    JtrainC=[JtrainC Jtem meansam];
    trlabC=[trlabC i*ones(1,sample_num+1)];
end

[~,alltrainsamnumC]=size(JtrainC);

KtrainC=zeros(alltrainsamnumC,alltrainsamnumC);
for ik=1:alltrainsamnumC
    for jk=ik:alltrainsamnumC
        x=JtrainC(:,ik)';
        y=JtrainC(:,jk)';
        KtrainC(ik,jk)=kernel(x,y,canshu);
        KtrainC(jk,ik)=KtrainC(ik,jk);
    end
end

 KtestC=zeros(alltrainsamnumC,size(Jtest,2));
for ite=1:size(Jtest,2)
    I=Jtest(:,ite);
    y=I';
    for ik=1:alltrainsamnumC    
        x=JtrainC(:,ik)';
        KtestC(ik,ite)=kernel(x,y,canshu);
    end
end

fprintf(['RateCKCSR: ' num2str(TLC(KtrainC,trlabC,KtestC,ttlab)) '\n']);